GridFire v0.7.6rc4.0 General Purpose Nuclear Network

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
gridfire::solver::PointSolverTimestepContext Struct Referencefinal

`#include <PointSolver.h>`

Inheritance diagram for gridfire::solver::PointSolverTimestepContext:
[legend]
Collaboration diagram for gridfire::solver::PointSolverTimestepContext:
[legend]

## Public Member Functions
| PointSolverTimestepContext (double t, const N_Vector &state, double dt, double last_step_time, double t9, double rho, size_t num_steps, const engine::DynamicEngine &engine, const std::vector< fourdst::atomic::Species > &networkSpecies, size_t currentConvergenceFailure, size_t currentNonlinearIterations, const std::map< fourdst::atomic::Species, std::unordered_map< std::string, double > > &reactionContributionMap, engine::scratch::StateBlob &state_ctx)
std::vector< std::tuple< std::string, std::string > > | describe () const override
| Describe the context for callback functions.
fourdst::composition::Composition | getPhysicalComposition () const
Public Member Functions inherited from gridfire::solver::TimestepContextBase
virtual | ~TimestepContextBase ()=default

## Public Attributes
const double | t
| Current integration time [s].
const N_Vector & | state
| Current CVODE state vector (N_Vector).
const double | dt
| Last step size [s].
const double | last_step_time
| Time at last callback [s].
const double | T9
| Temperature in GK.
const double | rho
| Density [g cm^-3].
const size_t | num_steps
| Number of CVODE steps taken so far.
const engine::DynamicEngine & | engine
| Reference to the engine.
const std::vector< fourdst::atomic::Species > & | networkSpecies
| Species layout.
const size_t | currentConvergenceFailures
| Total number of convergence failures.
const size_t | currentNonlinearIterations
| Total number of non-linear iterations.
const std::map< fourdst::atomic::Species, std::unordered_map< std::string, double > > & | reactionContributionMap
| Map of reaction contributions for the current step.
engine::scratch::StateBlob & | state_ctx
| Reference to the engine scratch state blob.
double | current_total_energy = 0.0
| Current energy generation rate [erg/g/s].
double | current_neutrino_energy_loss_rate = 0.0
| Current neutrino energy loss rate [erg/g/s].

## Constructor & Destructor Documentation

## ◆ PointSolverTimestepContext()

gridfire::solver::PointSolverTimestepContext::PointSolverTimestepContext | ( | double | t,
|  | const N_Vector & | state,
|  | double | dt,
|  | double | last_step_time,
|  | double | t9,
|  | double | rho,
|  | size_t | num_steps,
|  | const engine::DynamicEngine & | engine,
|  | const std::vector< fourdst::atomic::Species > & | networkSpecies,
|  | size_t | currentConvergenceFailure,
|  | size_t | currentNonlinearIterations,
|  | const std::map< fourdst::atomic::Species, std::unordered_map< std::string, double > > & | reactionContributionMap,
|  | engine::scratch::StateBlob & | state_ctx )

## Member Function Documentation

## ◆ describe()

std::vector< std::tuple< std::string, std::string > > gridfire::solver::PointSolverTimestepContext::describe | ( |  | ) | const
| nodiscard override virtual

Describe the context for callback functions.

Returns
  A vector of tuples, each containing a string for the parameters name and a string for its type.

This method should be overridden by derived classes to provide a description of the context that will be passed to the callback function. The intent of this method is that an end user can investigate the context that will be passed to the callback function, and use this information to craft their own callback function.

Implements gridfire::solver::TimestepContextBase.

## ◆ getPhysicalComposition()

fourdst::composition::Composition gridfire::solver::PointSolverTimestepContext::getPhysicalComposition | ( |  | ) | const
| nodiscard

## Member Data Documentation

## ◆ current_neutrino_energy_loss_rate

double gridfire::solver::PointSolverTimestepContext::current_neutrino_energy_loss_rate = 0.0

Current neutrino energy loss rate [erg/g/s].

## ◆ current_total_energy

double gridfire::solver::PointSolverTimestepContext::current_total_energy = 0.0

Current energy generation rate [erg/g/s].

## ◆ currentConvergenceFailures

const size_t gridfire::solver::PointSolverTimestepContext::currentConvergenceFailures

Total number of convergence failures.

## ◆ currentNonlinearIterations

const size_t gridfire::solver::PointSolverTimestepContext::currentNonlinearIterations

Total number of non-linear iterations.

## ◆ dt

const double gridfire::solver::PointSolverTimestepContext::dt

Last step size [s].

## ◆ engine

const engine::DynamicEngine& gridfire::solver::PointSolverTimestepContext::engine

Reference to the engine.

## ◆ last_step_time

const double gridfire::solver::PointSolverTimestepContext::last_step_time

Time at last callback [s].

## ◆ networkSpecies

const std::vector<fourdst::atomic::Species>& gridfire::solver::PointSolverTimestepContext::networkSpecies

Species layout.

## ◆ num_steps

const size_t gridfire::solver::PointSolverTimestepContext::num_steps

Number of CVODE steps taken so far.

## ◆ reactionContributionMap

const std::map<fourdst::atomic::Species, std::unordered_map<std::string, double> >& gridfire::solver::PointSolverTimestepContext::reactionContributionMap

Map of reaction contributions for the current step.

## ◆ rho

const double gridfire::solver::PointSolverTimestepContext::rho

Density [g cm^-3].

## ◆ state

const N_Vector& gridfire::solver::PointSolverTimestepContext::state

Current CVODE state vector (N_Vector).

## ◆ state_ctx

engine::scratch::StateBlob& gridfire::solver::PointSolverTimestepContext::state_ctx

Reference to the engine scratch state blob.

## ◆ t

const double gridfire::solver::PointSolverTimestepContext::t

Current integration time [s].

## ◆ T9

const double gridfire::solver::PointSolverTimestepContext::T9

Temperature in GK.

The documentation for this struct was generated from the following files:

- src/include/gridfire/solver/strategies/PointSolver.h
- src/lib/solver/strategies/PointSolver.cpp